//+------------------------------------------------------------------+
//|                                                   CandleTime.mq4 |
//|                                   Copyright  2012, Regczy Bla |
//|                                            http://www.regoczy.hu |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Regczy Bla"
#property link      "http://www.regoczy.hu"
#property version   "3.00"
#property strict

#property indicator_chart_window
//---- Include files
#include <RBForex\getPeriod.mqh>
#include <RBForex\TimeFrame2TXT.mqh>
#include <RBForex\getFontName.mqh>
#include <RBForex\RemoveObjects.mqh>
//--- input parameters
input    Timeframes  TimeFrame      = 0; 
input    Fonts       FontNum        = Font0;                            // Font name
extern   color       TextColor      = DimGray;                          // Text color
extern   int         TextSize       = 7;                                // Text size
extern   bool        ShowTimeFrame  = false,                            // Show timeframe
                     LabelBack      = false;                            // Text background
extern   string      UniqueID       = "1408307160";                     // Unique ID
//----
int                  TF;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//----
//---- Get period
   TF=getPeriod(TimeFrame);
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
//----
	RemoveObjects(UniqueID);
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   double b=Bid;
   datetime m=iTime(NULL, TF, 0)+TF*60-TimeCurrent(), t=Time[0];
   int s=(int)m%60;
   m=(m-m%60)/60;
   string tleft=IntegerToString(m)+(s<10?":0"+(string)s:":"+(string)s);
   DrawText("CandleTime", "  "+(ShowTimeFrame?TimeFrame2TXT(TF)+" time left < ":" < ")+tleft, t, b, ANCHOR_LEFT_UPPER);
   return(0);
}
//+------------------------------------------------------------------+
//| Draw Text                                                        |
//+------------------------------------------------------------------+
void DrawText(string Name, string Label, datetime Time1, double Price1, int Anchor) {
   string ObjName=Name+" "+UniqueID;
   if(ObjectFind  (ObjName)<0){
      ObjectCreate(ObjName, OBJ_TEXT, 0, Time1, Price1);
   } else {
      ObjectSet   (ObjName, OBJPROP_TIME1, Time1);
      ObjectSet   (ObjName, OBJPROP_PRICE1, Price1);
   }
   ObjectSet      (ObjName, OBJPROP_BACK, LabelBack);
   ObjectSet      (ObjName, OBJPROP_ANCHOR, Anchor);
   ObjectSetText  (ObjName, Label, TextSize, getFontName(FontNum), TextColor);
}
//+------------------------------------------------------------------+